
/*
 * DEFS.H
 *
 *
 *
 * (c)Copyright 1997, Matthew Dillon, All Rights Reserved.  Refer to
 *    the COPYRIGHT file in the base directory of this distribution
 *    for specific rights granted.
 */

#include "config.h"

#include <sys/types.h>
#include <sys/file.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <sys/ioctl.h>
#include <sys/socket.h>		/* internet sockets	*/
#include <sys/un.h>		/* unix domain sockets	*/
#include <sys/mman.h>		/* mmap()		*/
#include <netinet/in.h>		/* internet sockets	*/
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>

#if USE_BSTRING_H
#include <bstring.h>
#endif

#include <stdarg.h>
#include <stddef.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <netdb.h>		/* internet sockets	*/
#include <arpa/inet.h>
#include <signal.h>
#include <syslog.h>
#include <fcntl.h>
#include <pwd.h>
#include <grp.h>
#include <math.h>

#define Prototype extern

typedef struct {
    long	h1;
    long	h2;
} hash_t;

typedef struct History {
    unsigned long	next;	/* next link		*/
    unsigned long	gmt;	/* gmt time in minutes	*/
    hash_t		hv;	/* hash value		*/
    unsigned short	iter;	/* iteration		*/
    unsigned short	exp;	/* hours relative to gmt minutes */
} History;

#define HGF_FAST	0x01
#define HGF_NOSEARCH	0x02

typedef struct Node {
    struct Node		*no_Next;
    int			no_Value;
    char		*no_Name;
    char		*no_Name2;
} Node;

#define MAXLINE		16384
#define MAXGNAME	256
#define MAXFORKS	256
#define MAXFEEDS	128
#define MAXFDS		(MAXFORKS+MAXFEEDS+32)
#define HSIZE		(1024*1024)		
#define HMASK		(HSIZE-1)
#define MAXSIMUL	5	/* maximum simultanious from same label */

#define VERSION		"1.00"

#define RCOK		0	/* article accepted		*/
#define RCALREADY	1	/* we already have this article	*/
#define RCTRYAGAIN	2	/* something went wrong, requeue it for later */
#define RCREJECT	3	/* there is something wrong with your article */
#define RCERROR		4	/* an unexpected error occured  */

#define MAXFEEDTABLE	256

typedef struct Buffer {
    char		bu_Data[MAXLINE];
    int			bu_Beg;
    int			bu_NLScan;
    int			bu_End;
} Buffer;

#include "protos.h"

